#!/usr/bin/perl
#
# SnortCenter Copyright (C) 2001,2002 Stefan Dens
#
# Author: Stefan Dens <larc@pandora.be>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
require './web-lib.pl';
&init_config();
&ReadParse();
&header(undef, undef, undef, undef, 1, 1, undef, undef,undef);

$interface  = $in{'interface'};
$r_option  = $in{'r_option'};
#print $interface;

if ((!$in{'sensor_control'} && !$in{'sensor_cmd_file'} && !$in{'sensor_conf_file'} && !$in{'get_rule_path'}) || ($in{'local'} eq 'true')) {
    print "<TABLE align=center>
    <TR><TD align=center><B>SnortCenter Direct Sensor Console</B><TD></TR>
    <TR><TD align=center>
    <FORM method=POST>
    <input type=hidden name=local value=true>
    Interface: 
    <input type=text name=interface value='".$interface."' size=10>
    <input type=submit name=sensor_control value=status>
    <input type=submit name=sensor_control value=start>
    <input type=submit name=sensor_control value=restart>
    <input type=submit name=sensor_control value=stop>
    <input type=submit name=sensor_control value='snort version'>
    <input type=submit name=sensor_control value='system status'>
    </FORM>
    </TD></TR></TABLE><BR><TABLE align=center border=1><TR><TD>";
}

if($in{'sensor_cmd_file'}) { 
    if($in{'r_option'} ne '') {
        $r_option = $in{'r_option'};
    }
    open(CONF, "> $gconfig{'snort_rule_path'}/snort_cmd_line.$in{'interface'}$r_option") or die("Can't write to snort_cmd_line file: $!");
    chomp $in{'sensor_cmd_file'};
    print CONF ' '.$in{'sensor_cmd_file'};
    close(CONF);
    if($in{'local'} eq 'true') {
	print $in{'sensor_cmd_file'};
    }
}

if($in{'get_rule_path'}) { 
    print $gconfig{'snort_rule_path'};
}

if($in{'sensor_control'} eq 'restart') {
# stop
    if($in{'r_option'} ne '') {
        $r_option = $in{'r_option'};
    }
    $interface_pid = &get_interface_pid($interface,$r_option);
    if ($interface_pid ne 0) {
    @pids = &find_byname('snort');
    foreach $pid (@pids) {
	if($interface_pid =~ $pid) {
	    &kill_logged('TERM',$pid);
	    }
	}
    }
sleep(1);
# start
    $pid_found = "no";
    $interface_pid = &get_interface_pid($interface,$r_option);
    if ($interface_pid ne 0) {
	@pids = &find_byname('snort');
        foreach $pid (@pids) {
	    if($interface_pid =~ $pid) {
		$interface_pid = 1;
		$pid_found = "yes";
	    }
	}
    }
    if($interface_pid eq 0 || $pid_found eq "no") {
    	$cmd = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
	$cmd_line = `cat $cmd`;
	chomp($cmd_line);
	$temp = &tempname();
	$rv = &system_logged("$gconfig{'snort_path'}snort -T -i $interface $cmd_line </dev/null >$temp 2>&1");
	open(ARFILE, $temp);
	while(<ARFILE>) {
	    s/\r|\n/<BR>/g;
	    $out .= $_;
	}
	close(ARFILE);
	unlink($temp);
	if ($rv || $out =~ /Err/) {
	    $file = "$gconfig{'snort_rule_path'}/snort.".$interface.$r_option.".conf";
	    $cmd_file = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
    	    $rs = open(TEMP, "$file.good");
	    if($rs ne '') {
		open(TEMPA, ">$file");
		&copydata(TEMP, TEMPA);
		close(TEMPA);
		open(CMDTEMPA, ">$cmd_file");
		open(CMDTEMP, "$cmd_file.good");
		&copydata(CMDTEMP, CMDTEMPA);
		close(CMDTEMPA);
		close(CMDTEMP);
		$cmd = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
		$cmd_line = `cat $cmd`;
		chomp($cmd_line);
		$temp = &tempname();
		&system_logged("$gconfig{'snort_path'}snort -T -i $interface $cmd_line </dev/null >$temp 2>&1");
		open(ARFILE, $temp);
		while(<ARFILE>) {
		    s/\r|\n/<BR>/g;
		    $out_good .= $_;
		}
		close(ARFILE);
		unlink($temp);
		if ($out_good =~ /Err/) {
		    print "<CENTER><B>Error in $file and also in the last working config file!!!<BR>Check the errors below.</B></CENTER><HR>";
		}
		else {
		    $rv = &system_logged("$gconfig{'snort_path'}snort -D -i $interface $cmd_line </dev/null >$temp 2>&1");
    		    print "<CENTER><B>Error in $file<BR>Restarted snort with previous configuration!!!</B></CENTER><HR>";
		}
	    }
	    close(TEMP);
	    print "<B>Current config file error:</B><BR>$out";
	    if ($out_good =~ /Err/) { print "<HR><B>Last working config file error:</B><BR>$out_good"; }
	}
	else {
	    $file = "$gconfig{'snort_rule_path'}/snort.".$interface.$r_option.".conf";
	    $cmd_file = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
	    open(TEMP, "$file");
    	    open(TEMPA, ">$file.good");
	    &copydata(TEMP, TEMPA);
	    close(TEMP);
	    close(TEMPA);
	    open(CMDTEMP, "$cmd_file");
    	    open(CMDTEMPA, ">$cmd_file.good");
	    &copydata(CMDTEMP, CMDTEMPA);
	    close(CMDTEMP);
	    close(CMDTEMPA);
	    $rv = &system_logged("$gconfig{'snort_path'}snort -D -i $interface $cmd_line </dev/null >$temp 2>&1");
    	    print "Restarted Snort";
	}

    }
    else {
	print "Snort already running";
    }
}

if($in{'sensor_control'} eq 'start') {
    $pid_found = "no";
    if($in{'r_option'} ne '') {
        $r_option = $in{'r_option'};
    }
    $interface_pid = &get_interface_pid($interface,$r_option);
    if ($interface_pid ne 0) {
	@pids = &find_byname('snort');
        foreach $pid (@pids) {
	    if($interface_pid =~ $pid) {
		$interface_pid = 1;
		$pid_found = "yes";
	    }
	}
    }
    if($interface_pid eq 0 || $pid_found eq "no") {
	$cmd = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
	$cmd_line = `cat $cmd`;
	chomp($cmd_line);
	$temp = &tempname();
	$rv = &system_logged("$gconfig{'snort_path'}snort -T -i $interface $cmd_line </dev/null >$temp 2>&1");
	open(ARFILE, $temp);
	while(<ARFILE>) {
	    s/\r|\n/<BR>/g;
	    $out .= $_;
	}
	close(ARFILE);
	unlink($temp);
	if ($rv || $out =~ /Err/) {
	    $file = "$gconfig{'snort_rule_path'}/snort.".$interface.$r_option.".conf";
	    $cmd_file = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
    	    $rs = open(TEMP, "$file.good");
	    if($rs ne '') {
		open(TEMPA, ">$file");
		&copydata(TEMP, TEMPA);
		close(TEMPA);
		open(CMDTEMPA, ">$cmd_file");
		open(CMDTEMP, "$cmd_file.good");
		&copydata(CMDTEMP, CMDTEMPA);
		close(CMDTEMPA);
		close(CMDTEMP);
		$cmd = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
		$cmd_line = `cat $cmd`;
		chomp($cmd_line);
		$temp = &tempname();
		&system_logged("$gconfig{'snort_path'}snort -T -i $interface $cmd_line </dev/null >$temp 2>&1");
		open(ARFILE, $temp);
		while(<ARFILE>) {
		    s/\r|\n/<BR>/g;
		    $out_good .= $_;
		}
		close(ARFILE);
		unlink($temp);
		if ($out_good =~ /Err/) {
		    print "<CENTER><B>Error in $file and also in the last working config file!!!<BR>Check the errors below.</B></CENTER><HR>";
		}
		else {
		    $rv = &system_logged("$gconfig{'snort_path'}snort -D -i $interface $cmd_line </dev/null  >temp 2>&1");
    		    print "<CENTER><B>Error in $file<BR>Started snort with previous configuration!!!</B></CENTER><HR>";
		}
	    }
	    close(TEMP);
	    print "<B>Current config file error:</B><BR>$out";
	    if ($out_good =~ /Err/) { print "<HR><B>Last working config file error:</B><BR>$out_good"; }
	}
	else {
	    $file = "$gconfig{'snort_rule_path'}/snort.".$interface.$r_option.".conf";
	    $cmd_file = "$gconfig{'snort_rule_path'}/snort_cmd_line.$interface".$r_option;
	    open(TEMP, "$file");
    	    open(TEMPA, ">$file.good");
	    &copydata(TEMP, TEMPA);
	    close(TEMP);
	    close(TEMPA);
	    open(CMDTEMP, "$cmd_file");
    	    open(CMDTEMPA, ">$cmd_file.good");
	    &copydata(CMDTEMP, CMDTEMPA);
	    close(CMDTEMP);
	    close(CMDTEMPA);
	    $rv = &system_logged("$gconfig{'snort_path'}snort -D -i $interface $cmd_line </dev/null >$temp 2>&1");
	print "Started Snort";
	}

    }
    else {
	print "Snort already running";
    }
}

if($in{'sensor_control'} eq 'stop') {
    if($in{'r_option'} ne '') {
        $r_option = $in{'r_option'};
    }
    $interface_pid = &get_interface_pid($interface,$r_option);
    if ($interface_pid ne 0) {
    @pids = &find_byname('snort');
    foreach $pid (@pids) {
	if($interface_pid =~ $pid) {
	    &kill_logged('TERM',$pid);
	    if($in{'local'} eq 'true') {
		print "Stopped snort Pid# $pid<BR>";
	    }
	    else {
		print "Stopped snort Pid# $pid";    
	    }
	}
    }
}
}

sub get_interface_pid {
     open(INCLUDE, "/var/run/snort_".$_[0].$_[1].".pid") || return 0;
#    open(INCLUDE, "/var/run/snort_".$_[0].".pid") || return 0;
    $interface_pid = <INCLUDE>;
    close(INCLUDE);
    return $interface_pid;
}

if($in{'sensor_control'} eq 'status') {
    if($in{'r_option'} ne '') {
        $r_option = $in{'r_option'};
    }
    $pid_found = "no";
    $interface_pid = &get_interface_pid($interface,$r_option);
    @pids = &find_byname('snort');
    if ($interface_pid ne 0) {
    foreach $pid (@pids) {
	if($interface_pid =~ $pid) {
	    $pid_found = "yes";
	    if($in{'local'} eq 'true') {
		print "Snort is running Pid# $pid<BR>";
	    }
	    else {
		print "Snort is running Pid# $pid";    
	    }
	}
    }
}
if ($pid_found eq "no") { print "Snort not Running"; }
}

if($in{'sensor_control'} eq 'snort version') {
	$snortver=`$gconfig{'snort_path'}snort -V 2>&1 | grep "ersion"`;
	print "SnortCenter Sensor Agent Version ".`cat $config_directory/version`;
	print "<BR>Running<BR>Snort $snortver ";
}
if($in{'sensor_control'} eq 'system status') {
	&sysinfo;
	&show_snort_conf;
}

if($in{'local'} eq 'true') {
    print "</TD></TR></TABLE>";
}

sub show_snort_conf {
    if($in{'r_option'} ne '') {
	$r_option = $in{'r_option'};
    }
    my $file = "$gconfig{'snort_rule_path'}/snort.".$interface.$r_option.".conf";
    print "<BR><B>Snort conf file:</B>&nbsp;$file<BR> ";
    my $file_content = `head -5 $file`;
    $file_content =~ s/\n/<br>/g;
    print $file_content; 
}

sub sysinfo {
use POSIX qw(floor);
# specify your network interface card device name here (example: eth0)
$nic1 = $interface;

# enable/disable specific things
$s_html = 1;
$s_os = 1;
$s_cpu = 1;
$s_uptime = 1;
$s_load_average = 1;
$s_memory_usage = 1;
$s_disk_usage = 1;
$s_network_traffic1 = 1;

# you don't need to change these... ;)
$sysinfover = '2.64';
$sysinfodate = 'May 25, 2002,  3:05AM PST';

# get hostname, operating system/arch, and version
$os = `uname -s`;
$osn = `uname -n`;
$osv = `uname -r`;
$osm = `uname -m`;
chop($os);
chop($osn);
chop($osv);
chop($osm);
$uname = $os.' '.$osv.'/'.$osm;

# these shouldnt need changed, but if they ever do...
if($os =~ /^Linux$/) {
 $cpuinfo = '/proc/cpuinfo';
 $meminfo = '/proc/meminfo';
 $netdev = '/proc/net/dev';
$procuptime = '/proc/uptime';
} else {
 $dmesgboot = '/var/run/dmesg.boot';
}

# linux 2.2.x doesnt display active memory... maybe support it later
if($s_memory_usage eq 1) {
 if($os =~ /^Linux$/ && $osv =~ /^2.2.*$/) {
  $s_memory_usage = 0;
 }
}

# check if its smp or not and grab cpu speed and type
if($s_cpu eq 1) {
 if($os =~ /^FreeBSD$/) {
  $cpu = `cat $dmesgboot | grep MHz | grep CPU`;
  $smp = `cat $dmesgboot | grep cpu | wc -l | tr -d ' '`;
  @cpu = split(/: /, $cpu, 2);
  $cpu = $cpu[1];
 } elsif($os =~ /^NetBSD$/) {
  $cpu = `cat $dmesgboot | grep MHz | grep cpu0 | grep -v apic`;
  $smp = `cat $dmesgboot | grep MHz | grep cpu | grep -v apic | wc -l | tr -d ' '`;
  @cpu = split(/: /, $cpu, 2);
  $cpu = $cpu[1];
 } elsif($os =~ /^OpenBSD$/) {
  $cpu = `cat $dmesgboot | grep Hz | grep cpu0 | head -1`;
  $smp = '';
  @cpu = split(/: /, $cpu, 2);
  $cpu = $cpu[1];
 } elsif($os =~ /^Linux$/) {
  if(`cat $cpuinfo` =~ /pmac-generation/) {
   $cpu = `cat $cpuinfo | grep 'machine' | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.`cat $cpuinfo | grep 'cpu' | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.','.`cat $cpuinfo | grep 'clock' | head -1 | cut -f2 -d ':' | tr -d '\\n'`.' ';
   $smp = `cat $cpuinfo | grep processor | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /flags/) {
   $cpu = `cat $cpuinfo | grep 'model name' | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.','.`cat $cpuinfo | grep 'cpu MHz' | head -1 | cut -f2 -d ':' | tr -d '\\n'`.'MHz ';
   $smp = `cat $cpuinfo | grep processor | grep -v 'model name' | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /IA-64/) {
   $cpu = `cat $cpuinfo | grep 'family' | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.', '.sprintf('%.3f', `cat $cpuinfo | grep 'cpu MHz' | head -1 | cut -f2 -d ':' | tr -d '\\n'`).'MHz ';
   $smp = `cat $cpuinfo | grep processor | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /ITLB/) {
   $cpu = `cat $cpuinfo | grep 'cpu family' | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.' '.`cat $cpuinfo | grep 'cpu' | head -2 | tail -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.', '.sprintf('%.3f', `cat $cpuinfo | grep 'cpu MHz' | head -1 | cut -f2 -d ':' | tr -d '\\n'`).'MHz ';
   $smp = `cat $cpuinfo | grep processor | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /Processor/) {
   $cpu = `cat $cpuinfo | grep Processor | head -1 | cut -f2 -d ':'`;
   $smp = `cat $cpuinfo | grep Processor | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /State/) {
   $cpu = `cat $cpuinfo | grep 'cpu' | head -1 | cut -f2 -d ':'`;
   $smp = `cat $cpuinfo | grep CPU | wc -l | tr -d ' '`;
  } elsif(`cat $cpuinfo` =~ /page\ssize/) {
   $cpu = `cat $cpuinfo | grep cpu | head -1 | cut -f2 -d ':' | tr -d '\\n'`;
   $cpu = $cpu.`cat $cpuinfo | grep 'cpu model' | cut -f2 -d ':'`;
   $smp = `cat $cpuinfo | grep 'cpus detected' | cut -f2 -d ':' | tr -d ' '`;
  }
 } elsif($os =~ /^Darwin$/) {
  $cpu = `hostinfo | grep 'Processor type' | cut -f2 -d':'`;
  chop($cpu);
  $cpu = $cpu.','.`AppleSystemProfiler | grep 'Machine speed' | cut -f2 -d'='`;
  $smp = '';
 }
 chop($cpu);
 chop($smp);
 if($os =~ /^FreeBSD$/) {
  if($smp gt 1) {
   $processor = 'CPU: '.$smp.' x '.$cpu;
  } else {
   $processor = 'CPU: '.$cpu;
  }
 } elsif($os =~ /^NetBSD$/) {
  if($smp gt 1) {
   $processor = 'CPU: '.$smp.' x '.$cpu;
  } else {
   $processor = 'CPU: '.$cpu;
  }
 } elsif($os =~ /^OpenBSD$/) {
  $processor = 'CPU: '.$cpu;
 } elsif($os =~ /^Linux$/) {
  if($smp gt 1) {
   $processor = 'CPU: '.$smp.' x'.$cpu;
  } else {
   $processor = 'CPU:'.$cpu;
  }
 } elsif($os =~ /^Darwin$/) {
  $processor = 'CPU:'.$cpu;
 }
}

# of course we need our eliteness (uptime)
if($s_uptime eq 1) {
 if($os =~ /^FreeBSD$/) {
  $boottime = `/sbin/sysctl -n kern.boottime | awk '{print \$4}'`;
 } elsif($os =~ /^NetBSD$/) {
  $boottime = `/sbin/sysctl -n kern.boottime`;
 } elsif($os =~ /^OpenBSD$/) {
  $boottime = `/sbin/sysctl -n kern.boottime`;
 } elsif($os =~ /^Darwin$/) {
  $boottime = `/usr/sbin/sysctl -n kern.boottime`;
 }
 if($os =~ /^Linux$/) {
  @uptimesec = split(/ /, `cat $procuptime | tr -d '\\n'`);
  $ticks = $uptimesec[0];
  $ticks = sprintf('%2d', $ticks);
  $days = floor($ticks / 86400);
  $ticks %= 86400;
  $hours = floor($ticks / 3600);
  $ticks %= 3600;
  $mins = floor($ticks / 60);
  if($days eq 0) {
   $days = 0;
  } elsif($days eq 1) {
   $days = $days.' Day';
  } else {
   $days = $days.' Days';
  }
  if($hours eq 0) {
   $hours = 0;
  } elsif($hours eq 1) {
   $hours = $hours.' Hour';
  } else {
   $hours = $hours.' Hours';
  }
  if($mins eq 0) {
   $mins = 0;
  } elsif($mins eq 1) {
   $mins = $mins.' Minute';
  } else {
   $mins = $mins.' Minutes';
  }
 } else {
  chop($boottime);
  $boottime =~ s/,//g;
  $currenttime = `date +%s`;
  chop($currenttime);
  $ticks = $currenttime - $boottime;
  $days = floor($ticks / 86400);
  $ticks %= 86400;
  $hours = floor($ticks / 3600);
  $ticks %= 3600;
  $mins = floor($ticks / 60);
  if($days eq 0) {
   $days = 0;
  } elsif($days eq 1) {
   $days = $days.' Day';
  } else {
   $days = $days.' Days';
  }
  if($hours eq 0) {
   $hours = 0;
  } elsif($hours eq 1) {
   $hours = $hours.' Hour';
  } else {
   $hours = $hours.' Hours';
  }
  if($mins eq 0) {
   $mins = 0;
  } elsif($mins eq 1) {
   $mins = $mins.' Minute';
  } else {
   $mins = $mins.' Minutes';
  }
 }
 if($days eq 0 && $hours eq 0 && $mins ne 0) {
  $utime = $mins;
 } elsif($days eq 0 && $hours ne 0 && $mins ne 0) {
  $utime = $hours.', '.$mins;
 } elsif($days ne 0 && $hours ne 0 && $mins ne 0) {
  $utime = $days.', '.$hours.', '.$mins;
 } elsif($days ne 0 && $hours ne 0 && $mins eq 0) {
  $utime = $days.', '.$hours;
 } elsif($days ne 0 && $hours eq 0 && $mins ne 0) {
  $utime = $days.', '.$mins;
 } elsif($days ne 0 && $hours eq 0 && $mins eq 0) {
  $utime = $days;
 }
}

# get load average
if($s_load_average eq 1) {
 $load = `uptime`;
 chop($load);
 if($os =~ /^Linux$/) {
  @load = split(/average: /, $load, 2);
 } else {
  @load = split(/averages: /, $load, 2);
 }
 @load = split(/, /, $load[1], 2);
 $load = $load[0];
}

# memory usage
if($s_memory_usage eq 1) {
 if($os =~ /^Linux$/) {
  $memusage = `cat $meminfo | grep Active | awk '{print \$2}'` * 1024;
  chop($memusage);
  $memusage = $memusage / (1024 * 100);
  $totalmem = `cat $meminfo | grep MemTotal | awk '{print \$2}'` * 1024;
  chop($totalmem);
  $totalmem = $totalmem / (1024 * 100);
  $totalmem = sprintf('%.2f', $totalmem);
  $memusage = sprintf('%.2f', $memusage);
 } elsif($os =~ /^Darwin$/) {
  $memusage = `vm_stat | grep 'Pages active' | awk '{print \$3}'` * 4096;
  chop($memusage);
  $memusage = $memusage / (1024 * 100);
  $totalmem = `/usr/sbin/sysctl -n hw.physmem`;
  chop($totalmem);
  $totalmem = $totalmem / (1024 * 1024);
  $totalmem = sprintf('%.2f', $totalmem);
  $memusage = sprintf('%.2f', $memusage);
 } else {
  $memusage = `vmstat -s | grep 'pages active' | awk '{print \$1}'` * `vmstat -s | grep 'per page' | awk '{print \$1}'`;
  chop($memusage);
  $memusage = $memusage / (1024 * 100);
  $totalmem = `/sbin/sysctl -n hw.physmem`;
  chop($totalmem);
  $totalmem = $totalmem / (1024 * 1024);
  $totalmem = sprintf('%.2f', $totalmem);
  $memusage = sprintf('%.2f', $memusage);
 }
 $mempusage = sprintf('%.2f', $memusage / $totalmem * 100);
}

# hdd usage
if($s_disk_usage eq 1) {
 if($os =~ /^Linux$/) {
  $totalhdd = `df -Pk | grep -v Filesystem | awk '{ sum+=\$2 / 1024 / 1024}; END { print sum }'`;
  $hddusage = `df -Pk | grep -v Filesystem | awk '{ sum+=\$3 / 1024 / 1024}; END { print sum }'`;
 } else {
  $totalhdd = `df -k | grep -v Filesystem | awk '{ sum+=\$2 / 1024 / 1024}; END { print sum }'`;
  $hddusage = `df -k | grep -v Filesystem | awk '{ sum+=\$3 / 1024 / 1024}; END { print sum }'`;
 }
 chop($totalhdd);
 chop($hddusage);
 $totalhdd = sprintf('%.2f', $totalhdd);
 $hddusage = sprintf('%.2f', $hddusage);
 $hddpusage = sprintf('%.2f', $hddusage / $totalhdd * 100);

}

# lan (network) bandwidth usage
if($s_network_traffic1 eq 1) {
 if($os =~ /^FreeBSD$/) {
  $lan_in1 = `netstat -ibn | grep $nic1 | awk '{print \$7}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^NetBSD$/) {
  $lan_in1 = `netstat -ibn | grep $nic1 | awk '{print \$5}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^OpenBSD$/) {
  $lan_in1 = `netstat -ibn | grep $nic1 | awk '{print \$5}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^Linux$/) {
  $lan_in1 = `cat $netdev | grep $nic1 | cut -f2 -d ':' | awk '{print \$1}'` / 1024 / 1024;
 } elsif($os =~ /^Darwin$/) {
  $lan_in1 = `netstat -ibn | grep $nic1 | awk '{print \$7}' | head -1` / 1024 / 1024;
 }
 $lan_in1 = sprintf('%.2f', $lan_in1);
 chop($lan_in1);
 if($os =~ /^FreeBSD$/) {
  $lan_out1 = `netstat -ibn | grep $nic1 | awk '{print \$10}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^NetBSD$/) {
  $lan_out1 = `netstat -ibn | grep $nic1 | awk '{print \$6}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^OpenBSD$/) {
  $lan_out1 = `netstat -ibn | grep $nic1 | awk '{print \$6}' | head -1` / 1024 / 1024;
 } elsif($os =~ /^Linux$/) {
  $lan_out1 = `cat $netdev | grep $nic1 | cut -f2 -d ':' | awk '{print \$9}'` / 1024 / 1024;
 } elsif($os =~ /^Darwin$/) {
  $lan_out1 = `netstat -ibn | grep $nic1 | awk '{print \$10}' | head -1` / 1024 / 1024;
 }
 $lan_out1 = sprintf('%.2f', $lan_out1);
 chop($lan_out1);
}

# display results of everything
if($s_html eq 1) {
$bgcolor='WHITE';
$title_color = 'GREEN';
$text_color = 'BLACK';
$link_color = 'BLUE';
$vlink_color = 'PURPLE';
$warn_color = 'ORANGE';
$danger_color = 'RED';
$fixed_font_face = 'Clean, Fixed, Courier New, Courier, Terminal, Screen';
 
 print '   <table border=0>'."\n";
 if($s_os eq 1) {
  print '    <tr>'."\n";
  print "     <td><FONT color=$title_color>Operating System</font></td><td>".$uname.'</td>'."\n";
  print '    </tr>'."\n";
 }
 if($s_cpu eq 1) {
  print '    <tr>'."\n";
  print "     <td><FONT color=$title_color>CPU</font></td><td>".$processor.'</td>'."\n";
  print '    </tr>'."\n";
 }
 if($s_uptime eq 1) {
  print '    <tr>'."\n";
  print "     <td><FONT color=$title_color>Uptime</font></td><td>".$utime.'</td>'."\n";
  print '    </tr>'."\n";
 }
 if($s_load_average eq 1) {
  print '    <tr>'."\n";
  if($load gt 5) {
   print "     <td><FONT color=$title_color>Load Average</font></td><td><FONT color=$warn_color>".$load.'</font></td>'."\n";
  } else {
   print "     <td><FONT color=$title_color>Load Average</font></td><td>".$load.'</td>'."\n";
  }
  print '    </tr>'."\n";
 }
 if($s_memory_usage eq 1) {
  print '    <tr>'."\n";
  if($mempusage gt 75) {
   print "     <td><FONT color=$title_color>Memory Usage</font></td><td>".$memusage.'MB / '.$totalmem."MB <FONT color=$warn_color>(".$mempusage.'%)</font></td>'."\n";
  } elsif($mempusage gt 90) {
   print "     <td><FONT color=$title_color>Memory Usage</font></td><td>".$memusage.'MB / '.$totalmem."MB <FONT color=$danger_color>(".$mempusage.'%)</font></td>'."\n";
  } else {
   print "     <td><FONT color=$title_color>Memory Usage</font></td><td>".$memusage.'MB / '.$totalmem.'MB ('.$mempusage.'%)</td>'."\n";
  }
  print '    </tr>'."\n";
 }
 if($s_network_traffic1 eq 1) {
  print '    <tr>'."\n";
  print "     <td><FONT color=$title_color>Network Traffic In (".$nic1.')</font></td><td>'.$lan_in1.'MB</td>'."\n";
  print '    </tr>'."\n";
 }
 if($s_disk_usage eq 1) {
  @df = `df -h`;
  $title_line = shift @df;
  my ($dev, $size, $used, $avail, $capacity, $mount) = split(/\s+/, $title_line);
  print "<TR><TD colspan=2 align=center><TABLE width=100% border=0><TR><TD align=left><FONT color=$title_color>$dev</FONT></TD><TD align=left><FONT color=$title_color>$size</FONT></TD><TD align=left><FONT color=$title_color>$used</FONT></TD><TD align=left><FONT color=$title_color>$avail</FONT></TD><TD align=left><FONT color=$title_color>$capacity</FONT></TD><TD align=left><FONT color=$title_color>$mount</FONT></TD></TR>\n";

  foreach $line (@df) {
    my ($dev, $size, $used, $avail, $capacity, $mount) = split(/\s+/, $line);
 
    $capacity =~ s/%//;
    if ($capacity < 50) {
      $color = $text_color;
    } elsif ($capacity < 90) {
      $color = $warn_color;
    } else {
      $color = $danger_color;
    }
    
    print "<TR><TD align=left>$dev</TD><TD align=left>$size</TD><TD align=left>$used</TD><TD align=left>$avail</TD><TD align=left><FONT COLOR=$color>$capacity</FONT\></TD><TD align=left>$mount</TD></TR>\n";
  
  } ## for each line
  print "</TABLE></TD></TR>\n";
}

 print '   </table>'."\n";
}
}